using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;


namespace Permutation {
    /// <summary>
    /// Unique Permutations.
    /// Kerry Wong
    /// http://www.kerrywong.com
    /// 4/2005
    /// </summary>
    class Program {
        public ArrayList Unique(string s) {
            char[] c = s.ToCharArray();
            ArrayList ayList = new ArrayList();

            for (int i = 0; i < c.Length; i++)
                if (!ayList.Contains(c[i])) ayList.Add(c[i]);

            return ayList;
        }

        public ArrayList Permute(string s) {
            ArrayList tmpList = new ArrayList();
            ArrayList permList = new ArrayList();

            if (s.Length == 1) {
                if (!permList.Contains(s)) permList.Add(s);
                return permList;
            } else {
                ArrayList list = Unique(s);
                foreach (char c in list) {
                    for (int i = 0; i < s.Length; i++) {
                        string tempS = string.Empty;

                        if (s.Substring(i, 1) == c.ToString())
                            tempS = s.Remove(i, 1);
                        else
                            continue;

                        tmpList = Permute(tempS);
                        foreach (string t in tmpList) {
                            if (!permList.Contains(c.ToString() + t))
                                permList.Add(c.ToString() + t);
                        }
                    }
                }
            }

            return permList;
        }

        static void Main(string[] args) {
            Program p = new Program();

            ArrayList ayList = p.Permute("good");
            foreach (string s in ayList) Console.WriteLine(s);
            Console.WriteLine();
            Console.ReadKey();
        }
    }
}
